<?php

namespace App\Models;

use App\Http\Helpers\Hasher;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class Entity extends Model
{
    protected $table = 'entities';

    protected $appends = ['hash_id', 'entity_signature_list'];

    public function entity_signature()
    {
        return $this->hasMany('App\Models\EntitySignature', 'entity_id');
    }

    public function getHashIdAttribute()
    {
        return Hasher::encode('entities', $this->id);
    }

    public function getEntitySignatureListAttribute()
    {
        return $this->entity_signature()->get()->makeHidden(['entity_list']);
    }

    public function getUpdatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }

    public function getCreatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }
}
